> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/nemo-platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/nemo-platform/_mcp/server.

# List Steps

GET /apis/jobs/v2/workspaces/{workspace}/jobs/{name}/steps

List job steps with pagination and filtering.

Reference: https://docs.nvidia.com/nemo-platform/nemo-platform/v0.3.0/documentation/reference/api-reference/jobs/list-steps-apis-jobs-v-2-workspaces-workspace-jobs-name-steps-get

## Request

### Path parameters

- `name` (string, required)
- `workspace` (string, required)

### Query parameters

- `page` (integer, optional, default: 1) — Page number.
- `page_size` (integer, optional, default: 25) — Page size.
- `sort` (enum, optional, default: created_at) — The field to sort by. To sort in decreasing order, use `-` in front of the field name.
  - Allowed values: `created_at`, `-created_at`, `updated_at`, `-updated_at`
- `filter` (object, optional) — Filter steps by job, status, and source.
  - `job` (string, optional) — The ID of the job to filter steps by.
  - `status` (list of enum, optional) — The list of statuses to filter steps by.
    - Allowed values: `created`, `pending`, `active`, `cancelled`, `cancelling`, `error`, `completed`, `paused`, `pausing`, `resuming`
  - `source` (string, optional) — The source of the job steps.

## Response

### 200

Successful Response

- `data` (list of object, required)
  - `id` (string, required)
  - `job` (string, required)
  - `attempt_id` (string, required)
  - `fileset` (string, required)
  - `workspace` (string, required)
  - `name` (string, required)
  - `artifact_base_path` (string, optional) — Folder inside the fileset that this job's artifacts nest under; None when the job owns the whole fileset and its artifacts sit at the root
  - `step_spec` (object, optional) — Specification for a single step in a platform job.
    - `name` (string, required) — The name of the step. Must be unique for all steps in a job. Name must start with a lowercase letter, be 2-63 characters, and use lowercase letters, digits, hyphens, and dots (no consecutive hyphens, cannot end with a hyphen).
    - `executor` (object, required) — The executor for the step
      - `provider`: `cpu` (CPUExecutionProvider)
        - `container` (object, required) — Specification for a container configuration. Defines the container image and related configuration for job execution.
          - `image` (string, optional)
          - `entrypoint` (list of string, optional)
          - `command` (list of string, optional)
        - `profile` (string, optional, default: default)
        - `resources` (object, optional) — Resource requests and limits for CPU execution.
          - `requests` (object, optional) — Minimum resources requested for the container.
            - `cpu` (string, optional) — CPU specification (e.g., '250m', '1', '2.5').
            - `memory` (string, optional) — Memory specification (e.g., '128Mi', '1Gi', '512M').
          - `limits` (object, optional) — Maximum resources the container can use.
            - `cpu` (string, optional) — CPU specification (e.g., '250m', '1', '2.5').
            - `memory` (string, optional) — Memory specification (e.g., '128Mi', '1Gi', '512M').
          - `num_nodes` (integer, optional, default: 1) — Number of nodes to use.
          - `num_gpus` (integer, optional) — Step requesting number of GPUs.
          - `shm_size` (string, optional) — Shared memory (/dev/shm) size as a Kubernetes quantity (e.g. '1Gi', '4Gi'). Used for GPU and distributed-GPU job executors. When unset, defaults to 1Gi per allocated GPU.
      - `provider`: `gpu` (GPUExecutionProvider)
        - `container` (object, required) — Specification for a container configuration. Defines the container image and related configuration for job execution.
          - `image` (string, optional)
          - `entrypoint` (list of string, optional)
          - `command` (list of string, optional)
        - `profile` (string, optional, default: default)
        - `resources` (object, optional) — Resource requests and limits for GPU execution.
          - `requests` (object, optional) — Minimum resources requested for the container.
            - `cpu` (string, optional) — CPU specification (e.g., '250m', '1', '2.5').
            - `memory` (string, optional) — Memory specification (e.g., '128Mi', '1Gi', '512M').
          - `limits` (object, optional) — Maximum resources the container can use.
            - `cpu` (string, optional) — CPU specification (e.g., '250m', '1', '2.5').
            - `memory` (string, optional) — Memory specification (e.g., '128Mi', '1Gi', '512M').
          - `num_nodes` (integer, optional, default: 1) — Number of nodes to use.
          - `num_gpus` (integer, optional) — Step requesting number of GPUs.
          - `shm_size` (string, optional) — Shared memory (/dev/shm) size as a Kubernetes quantity (e.g. '1Gi', '4Gi'). Used for GPU and distributed-GPU job executors. When unset, defaults to 1Gi per allocated GPU.
      - `provider`: `gpu_distributed` (DistributedGPUExecutionProvider)
        - `container` (object, required) — Specification for a container configuration. Defines the container image and related configuration for job execution.
          - `image` (string, optional)
          - `entrypoint` (list of string, optional)
          - `command` (list of string, optional)
        - `profile` (string, optional, default: default)
        - `resources` (object, optional) — Resource requests and limits for distributed GPU execution.
          - `requests` (object, optional) — Minimum resources requested for the container.
            - `cpu` (string, optional) — CPU specification (e.g., '250m', '1', '2.5').
            - `memory` (string, optional) — Memory specification (e.g., '128Mi', '1Gi', '512M').
          - `limits` (object, optional) — Maximum resources the container can use.
            - `cpu` (string, optional) — CPU specification (e.g., '250m', '1', '2.5').
            - `memory` (string, optional) — Memory specification (e.g., '128Mi', '1Gi', '512M').
          - `num_nodes` (integer, optional, default: 1) — Number of nodes to use.
          - `num_gpus` (integer, optional) — Step requesting number of GPUs.
          - `shm_size` (string, optional) — Shared memory (/dev/shm) size as a Kubernetes quantity (e.g. '1Gi', '4Gi'). Used for GPU and distributed-GPU job executors. When unset, defaults to 1Gi per allocated GPU.
      - `provider`: `subprocess` (SubprocessExecutionProvider)
        - `command` (list of string, required)
        - `profile` (string, optional, default: default)
    - `environment` (list of object, optional) — Environment variables for the step
      - `name` (string, required) — The environment variable name
      - `value` (string, optional) — The environment variable value
      - `from_secret` (object, optional) — Reference to a secret environment variable to populate the environment variable
        - `name` (string, required) — The name of the secret to reference
    - `config` (map from string to any, optional) — Configuration for the step
    - `lifecycle` (object, optional) — Lifecycle configuration settings for the step
      - `staleness_timeout_seconds` (integer, optional, default: 0) — If every active task in the step goes this many seconds without an update, the step is terminated. A value of 0 disables staleness detection.
  - `status` (enum, optional, default: created) — Enumeration of possible job statuses. This enum represents the various states a job can be in during its lifecycle, from creation to a terminal state.
    - Allowed values: `created`, `pending`, `active`, `cancelled`, `cancelling`, `error`, `completed`, `paused`, `pausing`, `resuming`
  - `status_details` (map from string to any, optional)
  - `error_details` (map from string to any, optional)
  - `auth_context` (object, optional) — Auth context for task execution
    - `principal_id` (string, required) — The principal's unique identifier
    - `principal_email` (string, optional) — The principal's email address
    - `principal_groups` (list of string, optional) — Groups the principal belongs to
    - `principal_on_behalf_of` (string, optional) — If acting on behalf of another principal, their principal ID
    - `principal_on_behalf_of_groups` (list of string, optional) — Groups the on-behalf-of principal belongs to
    - `principal_on_behalf_of_email` (string, optional) — The on-behalf-of principal's email address
  - `created_at` (datetime, optional)
  - `updated_at` (datetime, optional)
- `pagination` (object, optional) — Pagination information.
  - `page` (integer, required) — The current page number.
  - `page_size` (integer, required) — The page size used for the query.
  - `current_page_size` (integer, required) — The size for the current page.
  - `total_pages` (integer, required) — The total number of pages.
  - `total_results` (integer, required) — The total number of results.
- `sort` (string, optional) — The field on which the results are sorted.
- `filter` (map from string to any, optional) — Filtering information.

## Examples

**Response**

```json
{
  "data": [
    {
      "id": "string",
      "job": "string",
      "attempt_id": "string",
      "fileset": "string",
      "workspace": "string",
      "name": "string",
      "artifact_base_path": "string",
      "step_spec": {
        "name": "preprocess",
        "executor": {
          "provider": "cpu",
          "container": {
            "image": "string",
            "entrypoint": [
              "string"
            ],
            "command": [
              "string"
            ]
          },
          "profile": "default",
          "resources": {
            "requests": {
              "cpu": "string",
              "memory": "string"
            },
            "limits": {
              "cpu": "string",
              "memory": "string"
            },
            "num_nodes": 1,
            "num_gpus": 1,
            "shm_size": "string"
          }
        },
        "environment": [
          {
            "name": "string",
            "value": "string",
            "from_secret": {
              "name": "string"
            }
          }
        ],
        "config": {},
        "lifecycle": {
          "staleness_timeout_seconds": 0
        }
      },
      "status": "created",
      "status_details": {},
      "error_details": {},
      "auth_context": {
        "principal_id": "string",
        "principal_email": "string",
        "principal_groups": [
          "string"
        ],
        "principal_on_behalf_of": "string",
        "principal_on_behalf_of_groups": [
          "string"
        ],
        "principal_on_behalf_of_email": "string"
      },
      "created_at": "2024-01-15T09:30:00Z",
      "updated_at": "2024-01-15T09:30:00Z"
    }
  ],
  "pagination": {
    "page": 1,
    "page_size": 1,
    "current_page_size": 1,
    "total_pages": 1,
    "total_results": 1
  },
  "sort": "string",
  "filter": {}
}
```

**SDK Code**

```python
import requests

url = "https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps"

response = requests.get(url)

print(response.json())
```

```javascript
const url = 'https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/apis/jobs/v2/workspaces/workspace/jobs/name/steps")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```